<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: Script/createDataViz.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: Script/createDataViz.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>


import {handleDataset} from "./handleModelData.js";

/**
 * Calculator module - See {@tutorial staticEngineModel}
 * @module b_create_caldata_buttons_client 
 * @description 
 * 
 *  This module is called from inside dispatcher.html there are 3 input forms
 *  which are connected to a http post action
 *  &lt;li>form action="/submit" method="POST"&lt;/li>          
 *  &lt;li>form action="/signals" method="POST"&lt;/li>          
 *  &lt;li>form action="/staticcode" method="POST"&lt;/li>          
 * &lt;br>
 * In addition to the 3 input forms there are 6 'div' elements which contain the following text headlines:
 * &lt;li>engine&lt;/li>
 * &lt;li>compressor&lt;/li>
 * &lt;li>turbine&lt;/li>
 * &lt;li>exhaust&lt;/li>
 * &lt;li>emissions&lt;/li>
 * &lt;li>roadloads&lt;/li>
 * &lt;br>
 * This dataviz module is filling data content into the 6 'div' elements by adding push buttons dynamically via
 * javascript. The javascript is adding data from a postgres table in JSON format to the push button objects.
 * The following table shows the key words of the JSON data files and explains the data content. 
 * &lt;br>&lt;br>
 * &lt;table>
 *   &lt;tr>&lt;th>Members&lt;/th>&lt;th>Editor&lt;/th>&lt;th>description&lt;/th>&lt;/tr>
 *   &lt;tr>&lt;td>EngineConstants&lt;/td>&lt;td>constant&lt;/td>&lt;td>physical constants&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineAmbientConditions&lt;/td>&lt;td>map&lt;/td>&lt;td>currently only set point for intake temperature&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineEta&lt;/td>&lt;td>map&lt;/td>&lt;td>energy efficiency map of combustion engine&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineFriction&lt;/td>&lt;td>map&lt;/td>&lt;td>engine friction map&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineVolumEff&lt;/td>&lt;td>map&lt;/td>&lt;td>engine volumetric efficiency&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineCompr&lt;/td>&lt;td>multiple curves&lt;/td>&lt;td>characteristic curves turbo charger compressor wheel&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineFullLoadData&lt;/td>&lt;td>multiple curves&lt;/td>&lt;td>engine full load characteristics&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineTurbine&lt;/td>&lt;td>multiple curves&lt;/td>&lt;td>characteristic curves for turbo charger turbine&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineExhaustParam&lt;/td>&lt;td>constant&lt;/td>&lt;td>physical constants&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineRawParticulates&lt;/td>&lt;td>map&lt;/td>&lt;td>characteristic curve for particulate emissions&lt;/td>&lt;/tr>
 *   &lt;tr>&lt;td>EngineRawNox&lt;/td>&lt;td>map&lt;/td>&lt;td>characteristic curve for NoX emissions&lt;/td>&lt;/tr> 
 *   &lt;tr>&lt;td>EngineRoadLoads&lt;/td>&lt;td>multiple curves&lt;/td>&lt;td>assumed torque and speed profile of typical drive situation&lt;/td>&lt;/tr> 
 * &lt;/table>
 * &lt;p> For each member a HTML button is created and a specific data handler is assigned to it which is getting activated once
 * the button is pressed. Each button gets a data member which contains the data according to the key in the table.&lt;/p>
 * &lt;p> [data visualization]{@link b_create_caldata_buttons_client.b_1_dataviz}&lt;/p>
 */


/** @function 
 * @description Find the details about the dataviz function in the corresponding namespace
 * @see [data visualization]{@link b_create_caldata_buttons_client.b_1_dataviz}
*/

function dataviz(socket){

var d3 = window.d3;

   // line module:modulename ~ function name
   /**
     * Foo object (@see: {@link module:b_create_caldata_buttons_client~dataviz})
     * @name b_create_caldata_buttons_client
     * @inner
     * @private
     * @memberof module:b_create_caldata_buttons_client
     * @property {Object} b_create_caldata_buttons_client - The foo object
     * @property {Object} b_create_caldata_buttons_client.b_1_dataviz - The bar object     
     * @property {function} b_create_caldata_buttons_client.b_1_dataviz.b_1_2_getClassNames - The bar object     
     * @property {function} b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames - The bar object     
     * @property {function} b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client - The bar object     
     */

    /**
     * Generate inner namespace of the startFileExample
     * @memberof b_create_caldata_buttons_client
     * @type {object}
     * @namespace b_create_caldata_buttons_client.b_1_dataviz
     * @description After the client initiated a get request for the root path 
     * the server replies by sending 'dispatcher.hmtl' to the client. The client
     * starts the embedded javascript by connecting socket.io. The server reacts
     * on the connection by starting the connect callback. The connect callback
     * reads the configuration data for the algebraic engine model from postgres
     * and sends it to the client by emitting the 'thermdata' event. 
     * &lt;br>&lt;br>Find more details about how the client processes the thermodynamic data by following the link.
     * &lt;br>[client : callback function loading event thermodynamic data]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client}
     * &lt;br>&lt;br>To get the details about how the server is triggered and sends its data to the client click on the
     * link below. 
     * &lt;br>[server : callback function on connection request thermodynamic data]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected}     
     * 
     */
 
function getClassNames(nodes)
{
     /**
     * This namespace describes the body of the function getClassNames.
     * The call argument of the function is the array of push button nodes.
     * All names of all push button nodes are returned as an array of string. 
     * &lt;br> Called by : [getter function for button names]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames}
     * 
     * @memberof b_create_caldata_buttons_client.b_1_dataviz
     * @type {object}
     * @namespace b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames
     * 
     */

      /**
        * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames
        * @type {Number[]}
        */       
      var name_ar = []

      /**
      * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames
      * @function forLoop
      * @param {number} i iterator
      * @param {number} nodes.length break condition : amount of nodes
      * @param {function} i++ increment iterator
      * @return {numbers[]} name_ar
      * @description this for loop iterates across all selected html button nodes
      * and returns their classnames in an array
      */
      for(var i=0;i&lt;nodes.length;i+=1)
      {
            /**
            * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames
            * @function name_ar_push
            * @param {string}  className  nodes[i].className gets pushed to name array
            */
            name_ar.push(nodes[i].className);
      }
      return name_ar;      
}
function getAllButtonNames()
{
      /**
      * This namespace describes the body of the getAllButtonNames function
      * which returns all classnames of all engine model related push buttons
      * to the &lt;br>['thermdata' event handler (calling function)]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client}.
      * @memberof b_create_caldata_buttons_client.b_1_dataviz
      * @type {object}
      * @namespace b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames
      * @see [getter function for classnames]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames}
      * 
      */
      
      var names_map = [];  

      /**
      * 
      * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames
      * @function d3
      * @param {function} selectAll('div.engine.button').nodes() get all html DOM button nodes
      * which are part of class engine and are inside a div element
      * @description return ENGINE button nodes
      * 
      */
      var nms = d3.selectAll('div').selectAll('.engine').selectAll('button').nodes();
      if(nms.length>0)
      {
            names_map.push(...getClassNames(nms));        
      }   

      /**
      * 
      * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames
      * @function d3
      * @param {function} selectAll('div.compressor.button').nodes() get all html DOM button nodes
      * which are part of class engine and are inside a div element
      * @description return COMPRESSOR button nodes
      * 
      */ 
      nms = d3.selectAll('div').selectAll('.compressor').selectAll('button').nodes();
      if(nms.length>0)
      {
            names_map.push(...getClassNames(nms));        
      }  

      /**
      * 
      * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames
      * @function d3
      * @param {function} selectAll('div.turbine.button').nodes() get all html DOM button nodes
      * which are part of class engine and are inside a div element
      * @description return TURBINE button nodes
      * 
      */   
      nms = d3.selectAll('div').selectAll('.turbine').selectAll('button').nodes();
      if(nms.length>0)
      {
            names_map.push(...getClassNames(nms));        
      }    

      /**
      * 
      * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames
      * @function d3
      * @param {function} selectAll('div.exhaust.button').nodes() get all html DOM button nodes
      * which are part of class engine and are inside a div element
      * @description return EXHAUST button nodes
      * 
      */ 
      nms = d3.selectAll('div').selectAll('.exhaust').selectAll('button').nodes();
      if(nms.length>0)
      {
            names_map.push(...getClassNames(nms));        
      }    

      /**
      * 
      * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames
      * @function d3
      * @param {function} selectAll('div.emissions.button').nodes() get all html DOM button nodes
      * which are part of class engine and are inside a div element
      * @description return EMISSION button nodes
      * 
      */ 
      nms = d3.selectAll('div').selectAll('.emissions').selectAll('button').nodes();
      if(nms.length>0)
      {
            names_map.push(...getClassNames(nms));        
      }    
      /**
      * 
      * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames
      * @function d3
      * @param {function} selectAll('div.roadloads.button').nodes() get all html DOM button nodes
      * which are part of class engine and are inside a div element
      * @description return ROADLOADS button nodes
      * 
      */ 
      nms = d3.selectAll('div').selectAll('.roadloads').selectAll('button').nodes();
      if(nms.length>0)
      {
            names_map.push(...getClassNames(nms));        
      }    
      return names_map;
}

 /**     
   * @memberof b_create_caldata_buttons_client.b_1_dataviz
   * @event thermdata
   * @type {object}   
   * @description ouput of the disconnected status on the standard console  
   * [client : callback function on receive event of thermodynamic data]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client}
   */
socket.on('thermdata', function(postgresData) {

      /**
      * call argument : postgresData - all data needed for the algebraic engine model
      * &lt;h4>Overview callback and surrounding html&lt;/h4>
      * This namespace describes the callback function body of client sided
      * thermdata event. The callback creates 4 different types of selection fields
      * implemented as push buttons as described in the list below. 
      * The push buttons for the engine characterizing data are implemented
      * as push buttons with a connected callback which gets activated by
      * clicking on the button. The other 3 types of buttons are activating
      * views by sending post requests to the server. The server reacts by
      * redirecting the request to the correct destination according to 
      * the 'ActiveView' state of this function selection view.
      * &lt;br>
      * The lists shows the 4 execution steps of this view
      * &lt;br>
      * &lt;li>create activation button for graphical editors by an input form &lt;a href="tutorial-webclients.html#post_reqs_graph">: graphical view : HTML elements&lt;/a>&lt;/li>
      * &lt;li>create activation button for simulation view by an input form &lt;a href="tutorial-webclients.html#post_reqs_signals">: simulation view : HTML elements&lt;/a>&lt;/li>
      * &lt;li>create activation button for static code analysis view by an input form &lt;a href="tutorial-webclients.html#post_reqs_staticA">: static code view : HTML elements&lt;/a>&lt;/li>
      * &lt;li>create push buttons for thermodynamic engine data (find the explanation of the subfunctions executed during the button creation in the links)
      *    &lt;br>&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;[1. get all already existing button names]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames}
      *    &lt;br>&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;[2. iterate across all data items and create a push button per item if it does not yet exist]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.forAllObjectinPostgresDataset} 
      *       &lt;br>&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;[2.1 add data handler, process data on mouse click]{@link module:d_handleModelData_client}
      * &lt;br>
      * &lt;br>
      * &lt;/li>
      * &lt;h4>Local editor&lt;/h4>
      * In addition to the graphical editing views there is a simple table editor for quick editing available in this function selection view. This
      * editor is mainly for editing constants but may also be used if no graphical 3d or 2d information is necessary. 
      * &lt;li>create activation button for static code analysis view by an input form &lt;a href="tutorial-webclients.html#post_reqs_table">:empty table HTML elements&lt;/a>&lt;/li>
      * &lt;br>
      * &lt;h4>Concept of this callback function&lt;/h4>
      * This function creates push buttons for each data element in the postgres
      * dataset. The dataset is coded in JSON. There are expected data elements in that
      * dataset. Usually all data is sent during send/receive event. It may happen
      * that the send/receive event gets interrupted and the dataset is sent multiple
      * times. In such a case only a subset of buttons is generated during an early
      * transmission. During later transmissions the data is sent again but already
      * existing buttons must no be created again. 
      * &lt;br>
      * program steps : 
      * &lt;li>copy json data to buffer 'obj'&lt;/li>
      * &lt;li>retrieve all class names of existing buttons : [getter function for button names]{@link b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames}&lt;/li>
      * &lt;li>create push buttons for data elements where there is not already a corresponding button&lt;/li>
      * &lt;li>connect mouse click handler to the pushbutton and use the classname of the pushbutton as a call argument&lt;/li>
      * &lt;br>
      * Result : each data element gets an own push button. Only the first transmission of a data element gets recognized. 
      * Further transmissions get ignored. A handler specific to the button/data element gets called as the push button
      * gets pushed. 
      * &lt;br>
      * mouse click event : {@link data.d_1_handler}
      * @memberof b_create_caldata_buttons_client.b_1_dataviz
      * @type {object}
      * @namespace b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client
      * 
      */

    /** 
     * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client 
     * @type {object} 
     * @description postgres data in json format for all parameters of the 
     * algrebraic theremodynamic engine model
     */
      var obj = postgresData;
      console.log(postgresData)
  
   /**
    * Connect
    * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client
    * @type {Array.&lt;string>}
    * 
    */  

    var names_vec = getAllButtonNames();

 /**
    * Connect
    * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client
    * @param {object[]} obj array of objects  
    * @function forAllObjectinPostgresDataset
    * @description if a key value of the postgres data is not yet used as a button name, a
    * button is created and named after the key value. A handler which is activated
    * on a mouse click it is attached to the button. The handler receives the postgres data
    * set as an argument. 
    * 
    * &lt;br>
    * variables : 
    * &lt;li>k - key name of data element (local to the loop)&lt;/li>
    * &lt;li>names_vec - array of class names of push buttons (created out of the existing push buttons)&lt;/li>
    * &lt;br>
    * if no push button class name is equal to the key name of the data object in the current loop revolution
    * a new push button is created by a switch case expression. Each case comes with a specific text for the 
    * button, a specific assignment to the html 'div' element which is identified by its classname and a
    * handler with a specific call argument. 
    * &lt;br>&lt;br>
    * Upper level div elements:
    * &lt;li>engine&lt;/li>
    * &lt;li>compressor&lt;/li>
    * &lt;li>turbine&lt;/li>
    * &lt;li>exhaust&lt;/li>
    * &lt;li>emissions&lt;/li>
    * &lt;li>roadloads&lt;/li>
    * &lt;br>
    * key names of data elements:
    * &lt;li>EngineConstants&lt;/li>
    * &lt;li>EngineAmbientConditions&lt;/li>
    * &lt;li>EngineEta&lt;/li>
    * &lt;li>EngineFriction&lt;/li>
    * &lt;li>EngineVolumEff&lt;/li>
    * &lt;li>EngineCompr&lt;/li>
    * &lt;li>EngineFullLoadData&lt;/li>
    * &lt;li>EngineTurbine&lt;/li>
    * &lt;li>EngineExhaustParam&lt;/li>
    * &lt;li>EngineRawParticulates&lt;/li>
    * &lt;li>EngineRawNox&lt;/li>
    * &lt;li>EngineRoadLoads&lt;/li>
    * &lt;br>
    * [mouse click event handler]{@link module:d_handleModelData_client}
    */  

    for(var k in obj){  
      var found = false;
      if(names_vec.length>0)
      {
            found = names_vec.includes(k);      
      }
      if(found==false)
      {
            switch(k)
            {
              case 'EngineConstants' : 
                    d3.select('.configData').select('.engine').append('button').text('Engine Constants').attr('class',k).on('click', function(){handleDataset(postgresData,'EngineConstants',socket);}); 
                    break;
              case 'EngineAmbientConditions' : 
                    d3.select('.configData').select('.engine').append('button').text('Engine Ambient Conditions').attr('class',k).on('click', function(){handleDataset(postgresData,'EngineAmbientConditions',socket);}); 
                    break;
              case 'EngineEta' : 
                    d3.select('.configData').select('.engine').append('button').text('Engine Efficiency').attr('class',k).on('click', function(){handleDataset(postgresData,'EngineEta',socket);}); 
                    break;
              case 'EngineFriction' : 
                    d3.select('.configData').select('.engine').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineFriction',socket);}); 
                    break;
              case 'EngineVolumEff' : 
                    d3.select('.configData').select('.engine').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineVolumEff',socket);});  
                    break;
              case 'EngineCompr' : 
                    d3.select('.configData').select('.compressor').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineCompr',socket);});  
                    break;
              case 'EngineFullLoadData' : 
                    d3.select('.configData').select('.compressor').append('button').text('Engine Parameters').attr('class',k).on('click', function(){handleDataset(postgresData,'EngineFullLoadData',socket,d3);}); 
                    break;      
              case 'EngineTurbine' : 
                    d3.select('.configData').select('.turbine').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineTurbine',socket);}); 
                    break;
              case 'EngineExhaustParam' : 
                    d3.select('.configData').select('.exhaust').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineExhaustParam',socket);}); 
                    break;
              case 'EngineRawParticulates' : 
                    d3.select('.configData').select('.emissions').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineRawParticulates',socket);}); 
                    break;
              case 'EngineRawNox' : 
                    d3.select('.configData').select('.emissions').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineRawNox',socket);}); 
                    break;
              case 'EngineRoadLoads' : 
                    d3.select('.configData').select('.roadloads').append('button').text(k).attr('class',k).on('click', function(){handleDataset(postgresData,'EngineRoadLoads',socket);}); 
                    break;
              //default : d3.select('.container').append('button').text(k).attr('class',k);
        
            }
      }
          
    }
  /**
    * @memberof b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client
    * @function handleDataset
    * @param {object} postgresData dataset received from postgres
    * @param {string} EngineAmbientConditions default call parameter
    * @param {object} socket socketIO connection to request server action 
    * @description as long as there is no push button clicked, the 
    * 'Engine Ambient Condition Data' is selected and prepared for 
    * further processing by calling the push button handler.
    * @see [mouse click event handler]{@link module:d_handleModelData_client}
    * 
    */  
    handleDataset(postgresData,'EngineAmbientConditions',socket);
   
   });
}

export {dataviz}</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
